/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/


#include <libc.h>
#include <string.h>
#include <stdio.h>

#include "OO7.hxx"
#include "GenParams.h"
#include "BenchParams.h"
#include "VarParams.h"

//////////////////////////////////////////////////////////////////
//
// Query #2 - 1% selection on AtomicParts via build date (the
// most recent 1% of AtomicParts.)
//
/////////////////////////////////////////////////////////////////

extern int	debugMode;

//////////////////////////////////////////////////////////////////
//
// Routine to do Query #2
//
//////////////////////////////////////////////////////////////////


int query2()
{
  // choose a range of dates with the appropriate selectivity

  int dateRange = (Query2Percent * (MaxAtomicDate - MinAtomicDate)) / 100;
  int lastDate = MinAtomicDate + dateRange;

  if (debugMode) {
    printf("    Running Query2 with dateRange = %d, lowerDate = %d\n",
	   dateRange, lastDate);
  }


  // first find the desired parts

  // now process the relevant parts

  int count = 0;
  int first = AtomicPart::extent_date->key(MinAtomicDate) ;
  int last = AtomicPart::extent_date->key(lastDate) ;
  int max = (TotalAtomicParts * Query2Percent) / 100 ;
  Iterator<AtomicPart> iter(*AtomicPart::extent_date,first, last);
  for (; iter.more(); iter.next()) {
    AtomicPart* atom = iter.get() ;
    if (debugMode) {
      printf("    In Query2, partId = %d, buildDate = %d\n",
	     atom->id, atom->buildDate);
    }
    atom->DoNothing();
    if (count++ == max) {
      break ;
    }
  }
  return count;
}

